Index: pjproject/trunk/third_party/srtp/crypto/hash/hmac_ossl.c
===================================================================
--- pjproject/trunk/third_party/srtp/crypto/hash/hmac_ossl.c	(revision 5261)
+++ pjproject/trunk/third_party/srtp/crypto/hash/hmac_ossl.c	(revision 5614)
@@ -2,5 +2,5 @@
  * hmac_ossl.c
  *
- * Implementation of hmac auth_type_t that leverages OpenSSL
+ * Implementation of hmac srtp_auth_type_t that leverages OpenSSL
  *
  * John A. Foley
@@ -9,5 +9,5 @@
 /*
  *
- * Copyright(c) 2013, Cisco Systems, Inc.
+ * Copyright(c) 2013-2017, Cisco Systems, Inc.
  * All rights reserved.
  *
@@ -47,13 +47,15 @@
 #endif
 
-#include "hmac.h"
+#include "auth.h"
 #include "alloc.h"
+#include "err.h"                /* for srtp_debug */
 #include <openssl/evp.h>
-
-#define HMAC_KEYLEN_MAX		20
+#include <openssl/hmac.h>
+
+#define SHA1_DIGEST_SIZE		20
 
 /* the debug module for authentiation */
 
-debug_module_t mod_hmac = {
+srtp_debug_module_t srtp_mod_hmac = {
     0,                /* debugging is off by default */
     "hmac sha-1 openssl"   /* printable name for module   */
@@ -61,186 +63,147 @@
 
 
-err_status_t
-hmac_alloc (auth_t **a, int key_len, int out_len)
-{
-    extern auth_type_t hmac;
-    uint8_t *pointer;
-    hmac_ctx_t *new_hmac_ctx;
-
-    debug_print(mod_hmac, "allocating auth func with key length %d", key_len);
-    debug_print(mod_hmac, "                          tag length %d", out_len);
-
-    /*
-     * check key length - note that we don't support keys larger
-     * than 20 bytes yet
-     */
-    if (key_len > HMAC_KEYLEN_MAX) {
-        return err_status_bad_param;
-    }
+static srtp_err_status_t srtp_hmac_alloc (srtp_auth_t **a, int key_len, int out_len)
+{
+    extern const srtp_auth_type_t srtp_hmac;
+
+    debug_print(srtp_mod_hmac, "allocating auth func with key length %d", key_len);
+    debug_print(srtp_mod_hmac, "                          tag length %d", out_len);
 
     /* check output length - should be less than 20 bytes */
-    if (out_len > HMAC_KEYLEN_MAX) {
-        return err_status_bad_param;
-    }
-
-    /* allocate memory for auth and hmac_ctx_t structures */
-    pointer = (uint8_t*)crypto_alloc(sizeof(hmac_ctx_t) + sizeof(auth_t));
-    if (pointer == NULL) {
-        return err_status_alloc_fail;
-    }
+    if (out_len > SHA1_DIGEST_SIZE) {
+        return srtp_err_status_bad_param;
+    }
+
+/* OpenSSL 1.1.0 made HMAC_CTX an opaque structure, which must be allocated
+   using HMAC_CTX_new.  But this function doesn't exist in OpenSSL 1.0.x. */
+#if OPENSSL_VERSION_NUMBER < 0x10100000L
+    {
+        /* allocate memory for auth and HMAC_CTX structures */
+        uint8_t* pointer;
+        HMAC_CTX *new_hmac_ctx;
+        pointer = (uint8_t*)srtp_crypto_alloc(sizeof(HMAC_CTX) + sizeof(srtp_auth_t));
+        if (pointer == NULL) {
+            return srtp_err_status_alloc_fail;
+        }
+        *a = (srtp_auth_t*)pointer;
+        (*a)->state = pointer + sizeof(srtp_auth_t);
+        new_hmac_ctx = (HMAC_CTX*)((*a)->state);
+
+        HMAC_CTX_init(new_hmac_ctx);
+    }
+
+#else
+    *a = (srtp_auth_t*)srtp_crypto_alloc(sizeof(srtp_auth_t));
+    if (*a == NULL) {
+        return srtp_err_status_alloc_fail;
+    }
+
+    (*a)->state = HMAC_CTX_new();
+    if ((*a)->state == NULL) {
+        srtp_crypto_free(*a);
+        *a = NULL;
+        return srtp_err_status_alloc_fail;
+    }
+#endif
 
     /* set pointers */
-    *a = (auth_t*)pointer;
-    (*a)->type = &hmac;
-    (*a)->state = pointer + sizeof(auth_t);
+    (*a)->type = &srtp_hmac;
     (*a)->out_len = out_len;
     (*a)->key_len = key_len;
     (*a)->prefix_len = 0;
-    new_hmac_ctx = (hmac_ctx_t*)((*a)->state);
-    memset(new_hmac_ctx, 0, sizeof(hmac_ctx_t));
-
-    /* increment global count of all hmac uses */
-    hmac.ref_count++;
-
-    return err_status_ok;
-}
-
-err_status_t
-hmac_dealloc (auth_t *a)
-{
-    extern auth_type_t hmac;
-    hmac_ctx_t *hmac_ctx;
-
-    hmac_ctx = (hmac_ctx_t*)a->state;
-    if (hmac_ctx->ctx_initialized) {
-        EVP_MD_CTX_cleanup(&hmac_ctx->ctx);
-    }
-    if (hmac_ctx->init_ctx_initialized) {
-        EVP_MD_CTX_cleanup(&hmac_ctx->init_ctx);
-    }
+
+    return srtp_err_status_ok;
+}
+
+static srtp_err_status_t srtp_hmac_dealloc (srtp_auth_t *a)
+{
+    HMAC_CTX *hmac_ctx;
+
+    hmac_ctx = (HMAC_CTX*)a->state;
+
+#if OPENSSL_VERSION_NUMBER < 0x10100000L
+    HMAC_CTX_cleanup(hmac_ctx);
 
     /* zeroize entire state*/
-    octet_string_set_to_zero((uint8_t*)a,
-                             sizeof(hmac_ctx_t) + sizeof(auth_t));
+    octet_string_set_to_zero(a, sizeof(HMAC_CTX) + sizeof(srtp_auth_t));
+
+#else
+    HMAC_CTX_free(hmac_ctx);
+
+    /* zeroize entire state*/
+    octet_string_set_to_zero(a, sizeof(srtp_auth_t));
+#endif
 
     /* free memory */
-    crypto_free(a);
-
-    /* decrement global count of all hmac uses */
-    hmac.ref_count--;
-
-    return err_status_ok;
-}
-
-err_status_t
-hmac_init (hmac_ctx_t *state, const uint8_t *key, int key_len)
-{
+    srtp_crypto_free(a);
+
+    return srtp_err_status_ok;
+}
+
+static srtp_err_status_t srtp_hmac_start (void *statev)
+{
+    HMAC_CTX *state = (HMAC_CTX *)statev;
+
+    if (HMAC_Init_ex(state, NULL, 0, NULL, NULL) == 0)
+        return srtp_err_status_auth_fail;
+
+    return srtp_err_status_ok;
+}
+
+static srtp_err_status_t srtp_hmac_init (void *statev, const uint8_t *key, int key_len)
+{
+    HMAC_CTX *state = (HMAC_CTX *)statev;
+
+    if (HMAC_Init_ex(state, key, key_len, EVP_sha1(), NULL) == 0)
+        return srtp_err_status_auth_fail;
+
+    return srtp_err_status_ok;
+}
+
+static srtp_err_status_t srtp_hmac_update (void *statev, const uint8_t *message, int msg_octets)
+{
+    HMAC_CTX *state = (HMAC_CTX *)statev;
+
+    debug_print(srtp_mod_hmac, "input: %s",
+                srtp_octet_string_hex_string(message, msg_octets));
+
+    if (HMAC_Update(state, message, msg_octets) == 0)
+        return srtp_err_status_auth_fail;
+
+    return srtp_err_status_ok;
+}
+
+static srtp_err_status_t srtp_hmac_compute (void *statev, const uint8_t *message,
+              int msg_octets, int tag_len, uint8_t *result)
+{
+    HMAC_CTX *state = (HMAC_CTX *)statev;
+    uint8_t hash_value[SHA1_DIGEST_SIZE];
     int i;
-    uint8_t ipad[64];
-
-    /*
-     * check key length - note that we don't support keys larger
-     * than 20 bytes yet
-     */
-    if (key_len > HMAC_KEYLEN_MAX) {
-        return err_status_bad_param;
-    }
-
-    /*
-     * set values of ipad and opad by exoring the key into the
-     * appropriate constant values
-     */
-    for (i = 0; i < key_len; i++) {
-        ipad[i] = key[i] ^ 0x36;
-        state->opad[i] = key[i] ^ 0x5c;
-    }
-    /* set the rest of ipad, opad to constant values */
-    for (; i < sizeof(ipad); i++) {
-        ipad[i] = 0x36;
-        ((uint8_t*)state->opad)[i] = 0x5c;
-    }
-
-    debug_print(mod_hmac, "ipad: %s", octet_string_hex_string(ipad, sizeof(ipad)));
-
-    /* initialize sha1 context */
-    sha1_init(&state->init_ctx);
-    state->init_ctx_initialized = 1;
-
-    /* hash ipad ^ key */
-    sha1_update(&state->init_ctx, ipad, sizeof(ipad));
-    return (hmac_start(state));
-}
-
-err_status_t
-hmac_start (hmac_ctx_t *state)
-{
-    if (state->ctx_initialized) {
-        EVP_MD_CTX_cleanup(&state->ctx);
-    }
-    if (!EVP_MD_CTX_copy(&state->ctx, &state->init_ctx)) {
-        return err_status_auth_fail;
-    } else {
-        state->ctx_initialized = 1;
-        return err_status_ok;
-    }
-}
-
-err_status_t
-hmac_update (hmac_ctx_t *state, const uint8_t *message, int msg_octets)
-{
-    debug_print(mod_hmac, "input: %s",
-                octet_string_hex_string(message, msg_octets));
-
-    /* hash message into sha1 context */
-    sha1_update(&state->ctx, message, msg_octets);
-
-    return err_status_ok;
-}
-
-err_status_t
-hmac_compute (hmac_ctx_t *state, const void *message,
-              int msg_octets, int tag_len, uint8_t *result)
-{
-    uint32_t hash_value[5];
-    uint32_t H[5];
-    int i;
+    unsigned int len;
 
     /* check tag length, return error if we can't provide the value expected */
-    if (tag_len > HMAC_KEYLEN_MAX) {
-        return err_status_bad_param;
+    if (tag_len > SHA1_DIGEST_SIZE) {
+        return srtp_err_status_bad_param;
     }
 
     /* hash message, copy output into H */
-    sha1_update(&state->ctx, message, msg_octets);
-    sha1_final(&state->ctx, H);
-
-    /*
-     * note that we don't need to debug_print() the input, since the
-     * function hmac_update() already did that for us
-     */
-    debug_print(mod_hmac, "intermediate state: %s",
-                octet_string_hex_string((uint8_t*)H, sizeof(H)));
-
-    /* re-initialize hash context */
-    sha1_init(&state->ctx);
-
-    /* hash opad ^ key  */
-    sha1_update(&state->ctx, (uint8_t*)state->opad, sizeof(state->opad));
-
-    /* hash the result of the inner hash */
-    sha1_update(&state->ctx, (uint8_t*)H, sizeof(H));
-
-    /* the result is returned in the array hash_value[] */
-    sha1_final(&state->ctx, hash_value);
+    if (HMAC_Update(state, message, msg_octets) == 0)
+        return srtp_err_status_auth_fail;
+
+    if (HMAC_Final(state, hash_value, &len) == 0)
+        return srtp_err_status_auth_fail;
+
+    if (len < tag_len)
+        return srtp_err_status_auth_fail;
 
     /* copy hash_value to *result */
     for (i = 0; i < tag_len; i++) {
-        result[i] = ((uint8_t*)hash_value)[i];
-    }
-
-    debug_print(mod_hmac, "output: %s",
-                octet_string_hex_string((uint8_t*)hash_value, tag_len));
-
-    return err_status_ok;
+        result[i] = hash_value[i];
+    }
+
+    debug_print(srtp_mod_hmac, "output: %s",
+                srtp_octet_string_hex_string(hash_value, tag_len));
+
+    return srtp_err_status_ok;
 }
 
@@ -248,6 +211,5 @@
 /* begin test case 0 */
 
-uint8_t
-    hmac_test_case_0_key[HMAC_KEYLEN_MAX] = {
+static const uint8_t srtp_hmac_test_case_0_key[SHA1_DIGEST_SIZE] = {
     0x0b, 0x0b, 0x0b, 0x0b, 0x0b, 0x0b, 0x0b, 0x0b,
     0x0b, 0x0b, 0x0b, 0x0b, 0x0b, 0x0b, 0x0b, 0x0b,
@@ -255,11 +217,9 @@
 };
 
-uint8_t
-    hmac_test_case_0_data[8] = {
+static const uint8_t srtp_hmac_test_case_0_data[8] = {
     0x48, 0x69, 0x20, 0x54, 0x68, 0x65, 0x72, 0x65 /* "Hi There" */
 };
 
-uint8_t
-    hmac_test_case_0_tag[HMAC_KEYLEN_MAX] = {
+static const uint8_t srtp_hmac_test_case_0_tag[SHA1_DIGEST_SIZE] = {
     0xb6, 0x17, 0x31, 0x86, 0x55, 0x05, 0x72, 0x64,
     0xe2, 0x8b, 0xc0, 0xb6, 0xfb, 0x37, 0x8c, 0x8e,
@@ -267,12 +227,11 @@
 };
 
-auth_test_case_t
-    hmac_test_case_0 = {
-    sizeof(hmac_test_case_0_key),    /* octets in key            */
-    hmac_test_case_0_key,            /* key                      */
-    sizeof(hmac_test_case_0_data),   /* octets in data           */
-    hmac_test_case_0_data,           /* data                     */
-    sizeof(hmac_test_case_0_tag),    /* octets in tag            */
-    hmac_test_case_0_tag,            /* tag                      */
+static const srtp_auth_test_case_t srtp_hmac_test_case_0 = {
+    sizeof(srtp_hmac_test_case_0_key),    /* octets in key            */
+    srtp_hmac_test_case_0_key,            /* key                      */
+    sizeof(srtp_hmac_test_case_0_data),   /* octets in data           */
+    srtp_hmac_test_case_0_data,           /* data                     */
+    sizeof(srtp_hmac_test_case_0_tag),    /* octets in tag            */
+    srtp_hmac_test_case_0_tag,            /* tag                      */
     NULL                             /* pointer to next testcase */
 };
@@ -280,23 +239,20 @@
 /* end test case 0 */
 
-char hmac_description[] = "hmac sha-1 authentication function";
+static const char srtp_hmac_description[] = "hmac sha-1 authentication function";
 
 /*
- * auth_type_t hmac is the hmac metaobject
+ * srtp_auth_type_t hmac is the hmac metaobject
  */
 
-auth_type_t
-    hmac  = {
-    (auth_alloc_func)	hmac_alloc,
-    (auth_dealloc_func)	hmac_dealloc,
-    (auth_init_func)	hmac_init,
-    (auth_compute_func)	hmac_compute,
-    (auth_update_func)	hmac_update,
-    (auth_start_func)	hmac_start,
-    (char*)		hmac_description,
-    (int)		0,           /* instance count */
-    (auth_test_case_t*)	&hmac_test_case_0,
-    (debug_module_t*)	&mod_hmac,
-    (auth_type_id_t)    HMAC_SHA1
-};
-
+const srtp_auth_type_t srtp_hmac  = {
+    srtp_hmac_alloc,
+    srtp_hmac_dealloc,
+    srtp_hmac_init,
+    srtp_hmac_compute,
+    srtp_hmac_update,
+    srtp_hmac_start,
+    srtp_hmac_description,
+    &srtp_hmac_test_case_0,
+    SRTP_HMAC_SHA1
+};
+